Imports System.Diagnostics
Imports System.Data
Imports Infragistics
Imports Infragistics.Win
Imports Infragistics.Win.UltraWinGrid

Public Class Form1

#Region "UltraGrid1_KeyPress"

    Private Sub UltraGrid1_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles UltraGrid1.KeyPress
        Debug.WriteLine("-----------------------------------------")
        Debug.Indent()
        Debug.WriteLine("ultraGrid1_KeyPress")
        Debug.WriteLine(String.Format("Key Char: {0}", e.KeyChar.ToString()))

        Dim grid As UltraGrid = TryCast(sender, UltraGrid)
        If Not Char.IsControl(e.KeyChar) And Not grid Is Nothing And Not grid.ActiveCell Is Nothing And TypeOf grid.ActiveCell.EditorResolved Is EditorWithText And grid.ActiveCell.IsInEditMode = False Then

            grid.PerformAction(UltraGridAction.EnterEditMode)
            Dim editor As EditorWithText = CType(grid.ActiveCell.EditorResolved, EditorWithText)
            editor.TextBox.Text = e.KeyChar.ToString()
            editor.TextBox.SelectionStart = 1
        End If
    End Sub

#End Region

#Region "Form1_Load"

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Debug.WriteLine("-----------------------------------------")
        Debug.Indent()
        Debug.WriteLine("Form1_Load")

        Me.UltraGrid1.DataSource = GetDataSet()
        Debug.Unindent()
    End Sub

#End Region

#Region "GetDataSet"

    Private Function GetDataSet() As DataSet
        Debug.WriteLine("-----------------------------------------")
        Debug.Indent()
        Debug.WriteLine("GetDataSet")

        Dim parentChildSet As DataSet = New DataSet()
        Dim parentTable As DataTable = New DataTable()
        Dim childTable As DataTable = New DataTable()
        Dim row As DataRow
        parentTable.Columns.Add("ParentID")
        parentTable.Columns.Add("SampleFirstName_Parent")
        parentTable.Columns.Add("SampleLastName_Parent")

        childTable.Columns.Add("ChildID")
        childTable.Columns.Add("SampleFirstName_Child")
        childTable.Columns.Add("SampleLastName_Child")
        childTable.Columns.Add("ParentID")

        For i As Integer = 0 To 10
            row = parentTable.NewRow()
            row("ParentID") = "ParentID -- " + i.ToString()
            row("SampleFirstName_Parent") = "First Name_Parent -- " + i.ToString()
            row("SampleLastName_Parent") = "Last Name_Parent -- " + i.ToString()

            parentTable.Rows.Add(row)

            For j As Integer = 0 To 5
                row = childTable.NewRow()
                row("ChildID") = "ChildID -- " + j.ToString()
                row("SampleFirstName_Child") = "First Name _ Child -- " + j.ToString()
                row("SampleLastName_Child") = "Last Name _ Child -- " + j.ToString()
                row("ParentID") = "ParentID -- " + i.ToString()

                childTable.Rows.Add(row)
            Next

        Next

        parentChildSet.Tables.Add(parentTable)
        parentChildSet.AcceptChanges()

        Debug.Unindent()
        Return parentChildSet
    End Function

#End Region

#Region "UltraGrid1_InitializeLayout"

    Private Sub UltraGrid1_InitializeLayout(ByVal sender As System.Object, ByVal e As Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs) Handles UltraGrid1.InitializeLayout
        Debug.WriteLine("-----------------------------------------")
        Debug.Indent()
        Debug.WriteLine("ultraGrid1_InitializeLayout")

        'e.Layout.Override.AllowAddNew = AllowAddNew.TabRepeat;
        e.Layout.Override.AllowAddNew = AllowAddNew.Yes
        'e.Layout.AddNewBox.Hidden = false
        e.Layout.Override.AllowUpdate = DefaultableBoolean.True
        e.Layout.Override.CellClickAction = CellClickAction.CellSelect

        Debug.Unindent()
    End Sub

#End Region

End Class
